#pragma once

#include <TabDockingBox.h>
#include "dialog/AlphaDialog.h"
#include "MtlPrivateProfile.h"
#include "DonutPFunc.h"

//2000ȍ~̋@\ƂĒ`萔(WINNT=>0x500)
#ifndef WS_EX_LAYERED
#define WS_EX_LAYERED	0x00080000
#define LWA_ALPHA		0x00000002
#endif


/*
	CLayerFunctionManager
	Windows2000ȍ~ŎꂽCEBhE()@\gpł邩ǂ`FbN
*/
class CLayerFunctionManager
{
protected:
	static HMODULE m_hLayerModule;
	static int m_nCount;
	typedef BOOL (WINAPI *FPSETLAYEREDWINDOWATTRIBUTES)(HWND, COLORREF, BYTE, DWORD);

	static void Init();
	static void Term();
public:
	static void Inc();
	static void Dec();

	static bool CanUseLayer();
	static BOOL SetLayeredWindowAttributes(HWND hwnd, COLORREF crKey, BYTE bAlpha, DWORD dwFlags);
};


/*
	CDockingChildBaseT
	C@\ɑΉhbLOEBhE̊NX

	hNXhbLOEBhEƂĎgƃt[g̃ReLXgj[
	At@l̕ύXڂǉA瓧xύXł@͂
*/

typedef dockwins::CDockingWindowTraits<dockwins::COutlookLikeCaption,
				WS_OVERLAPPEDWINDOW | WS_POPUP | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
				WS_EX_TOOLWINDOW | WS_EX_LAYERED>
		CDockingChildBaseTraits;

typedef dockwins::CDockingBoxTraits<dockwins::COutlookLikeExCaption,
				WS_OVERLAPPEDWINDOW|WS_POPUP|WS_CLIPCHILDREN|WS_CLIPSIBLINGS,
				WS_EX_TOOLWINDOW|WS_EX_LAYERED>
		CBoxDockingChildBaseTraits;

typedef dockwins::CBoxedDockingWindowTraits<dockwins::COutlookLikeExCaption,
				dockwins::CTabDockingBox<CBoxDockingChildBaseTraits>,
				WS_OVERLAPPEDWINDOW|WS_POPUP|WS_VISIBLE|WS_CLIPCHILDREN|WS_CLIPSIBLINGS,
				WS_EX_TOOLWINDOW|WS_EX_LAYERED>
		CBoxedDockingChildBaseTraits;


//template<class T, class TBase = CWindow, class TWinTrait = CDockingChildBaseTraits>
//template<class T, class TBase = CWindow, class TWinTrait = CBoxedDockingChildBaseTraits>
template<class T, class TBase = CWindow, class TWinTrait = dockwins::COutlookLikeExBoxedDockingWindowTraits>
class ATL_NO_VTABLE CDockingChildBaseT
	: public dockwins::CBoxedDockingWindowImpl<T,TBase,TWinTrait>
	//: public dockwins::CTitleDockingWindowImpl<T,TBase,TWinTrait>
{
protected:
	DWORD m_dwAlpha; //At@l(0:S 255:Ss)
	bool m_bAddMenu;

	typedef CDockingChildBaseT<T,TBase,TWinTrait> thisClass;
	typedef dockwins::CBoxedDockingWindowImpl<T,TBase,TWinTrait> baseClass;
	//typedef dockwins::CTitleDockingWindowImpl<T,TBase,TWinTrait> baseClass;

	//֐
	void RefreshAlpha(DWORD dwAlpha);
	BOOL SetLayeredWindowAttributes(COLORREF crKey, BYTE bAlpha, DWORD dwFlags);

	//bZ[Wnh
	LRESULT OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnEraseBackGround(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnNCRButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

public:

	//RXgN^
	CDockingChildBaseT();

	//fXgN^
	virtual ~CDockingChildBaseT();

	//\bh
	void SetAlpha(DWORD dwAlpha);
	void SetIcon(LPCTSTR FileName); //^uɃACR\

	//NX̐U镑I[o[Ch
	bool BeginMoving(const POINT& point);
	void OnDocked(HDOCKBAR hBar,bool bHorizontal);
	void OnUndocked(HDOCKBAR hBar);
	bool GetDockingWindowPlacement(dockwins::DFDOCKPOSEX* pHdr) const;
	bool SetDockingWindowPlacement(dockwins::DFDOCKPOSEX* pHdr);

	//bZ[W}bv
	BEGIN_MSG_MAP(thisClass)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_SYSCOMMAND,OnSysCommand)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBackGround)
		MESSAGE_HANDLER(WM_NCRBUTTONDOWN, OnNCRButtonDown)
		CHAIN_MSG_MAP(baseClass)
	END_MSG_MAP()
};

template<class T, class TBase, class TWinTrait>
CDockingChildBaseT<T,TBase,TWinTrait>::CDockingChildBaseT()
	: m_dwAlpha(255), m_bAddMenu(false)
{
	CLayerFunctionManager::Inc();
}

template<class T, class TBase, class TWinTrait>
CDockingChildBaseT<T,TBase,TWinTrait>::~CDockingChildBaseT()
{
	CLayerFunctionManager::Dec();
}

//template]X̂͂邢̂Ń}N
#define DOCKINGCHILDBASEIMPL(rettype) \
template<class T, class TBase, class TWinTrait> \
rettype CDockingChildBaseT<T,TBase,TWinTrait>


//\bh
DOCKINGCHILDBASEIMPL(void)::SetAlpha(DWORD dwAlpha)
{
	RefreshAlpha(dwAlpha);
	m_dwAlpha = dwAlpha;
}

DOCKINGCHILDBASEIMPL(void)::RefreshAlpha(DWORD dwAlpha)
{
	if(IsDocking()) return;

	if(dwAlpha==255){
		SetWindowLong(GWL_EXSTYLE,GetWindowLong(GWL_EXSTYLE)&~WS_EX_LAYERED);
		InvalidateRect(NULL);
	}else{
		SetWindowLong(GWL_EXSTYLE,GetWindowLong(GWL_EXSTYLE)|WS_EX_LAYERED);
		SetLayeredWindowAttributes(0,(BYTE)dwAlpha,LWA_ALPHA);
	}
}

DOCKINGCHILDBASEIMPL(void)::SetIcon(LPCTSTR FileName)
{
	CString pass = _GetSkinDir() + FileName;
	SHFILEINFO shfi;
	::SHGetFileInfo(pass.GetBuffer(0), 0, &shfi, sizeof(SHFILEINFO), SHGFI_ICON | SHGFI_SMALLICON );
	baseClass::SetIcon(shfi.hIcon, FALSE);
}

//NX̐U镑I[o[Ch
DOCKINGCHILDBASEIMPL(bool)::BeginMoving(const POINT& point)
{
	//͈ړ̕`悪܂Ȃꍇ̂őŜĕ`悵Ă܂B
	bool bRet = baseClass::BeginMoving(point);
	if(m_dwAlpha<255)
		::InvalidateRect(NULL,NULL,TRUE);
	return bRet;
}
DOCKINGCHILDBASEIMPL(void)::OnDocked(HDOCKBAR hBar,bool bHorizontal)
{
	//hbLO
	//TCYύXp̋EȂ
	SetWindowLong( GWL_STYLE, GetWindowLong(GWL_STYLE)&(~WS_SIZEBOX));

	//
	::SetWindowLong(m_hWnd,GWL_EXSTYLE,::GetWindowLong(m_hWnd,GWL_EXSTYLE)&~WS_EX_LAYERED);
	baseClass::OnDocked(hBar,bHorizontal);
}
DOCKINGCHILDBASEIMPL(void)::OnUndocked(HDOCKBAR hBar)
{
	//hbLO
	//TCYύXp̋Epӂ
	DWORD dwStyle = GetWindowLong(GWL_STYLE) | WS_SIZEBOX;
	SetWindowLong( GWL_STYLE , dwStyle);

	//At@l255Ȃ瓧s
	if(m_dwAlpha<255){
		::SetWindowLong(m_hWnd,GWL_EXSTYLE,::GetWindowLong(m_hWnd,GWL_EXSTYLE)|WS_EX_LAYERED);
		SetLayeredWindowAttributes(0,(BYTE)m_dwAlpha,LWA_ALPHA);
	}
	baseClass::OnUndocked(hBar);
}

DOCKINGCHILDBASEIMPL(bool)::GetDockingWindowPlacement(dockwins::DFDOCKPOSEX* pHdr) const
{
	//Z[uf[^vĂ
	//̃f[^^(DFDOCKPOSEX)𖳗At@l悤ɉ
	DWORD dwAlpha = m_dwAlpha;
	if(dwAlpha < 16 || dwAlpha > 255) dwAlpha = 255;
	pHdr->exData.dwWindowAlpha = dwAlpha;
	return baseClass::GetDockingWindowPlacement(pHdr);
}

DOCKINGCHILDBASEIMPL(bool)::SetDockingWindowPlacement(dockwins::DFDOCKPOSEX* pHdr)
{
	//f[^[hꂽƂʒmĂ
	//DFDOCKPOSEX^Ēǉf[^At@l󂯎
	DWORD dwAlpha = pHdr->exData.dwWindowAlpha;
	if(dwAlpha < 16 || dwAlpha > 255) dwAlpha = 255;
	SetAlpha(dwAlpha);
	return baseClass::SetDockingWindowPlacement(pHdr);
}

//bZ[W
DOCKINGCHILDBASEIMPL(LRESULT)::OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled=!(static_cast<T*>(this)->CanBeClosed(wParam));
	return 0;
}

DOCKINGCHILDBASEIMPL(LRESULT)::OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	WORD wID = (WORD)wParam;
	if(wID == ID_SELECT_ALPHA){
		CAlphaDialog dlg((BYTE)m_dwAlpha);
		INT_PTR nRet = dlg.DoModal();
		if(nRet == IDOK){
			SetAlpha(dlg.GetAlpha());
		}
	}
	return 0;
}

DOCKINGCHILDBASEIMPL(LRESULT)::OnEraseBackGround(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	//x[XNXwiȂ悤ɂ̂Aߎɂ͂ɂȂ̂
	//ߎ͔wiƂɂ
	bHandled = FALSE;
	if(!IsDocking() && m_dwAlpha<255){
		DefWindowProc(uMsg,wParam,lParam);
		return 0;
	}
	return 1;
}

DOCKINGCHILDBASEIMPL(LRESULT)::OnNCRButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	if(!m_bAddMenu){
		if(_CheckOsVersion_2000Later() && CLayerFunctionManager::CanUseLayer()){
			CMenuHandle menu = GetSystemMenu(FALSE);
			menu.InsertMenu(0,MF_BYPOSITION,ID_SELECT_ALPHA,"xݒ肷");
			menu.InsertMenu(1,MF_BYPOSITION|MF_SEPARATOR);
		}
		m_bAddMenu = true;
	}
	return 0;
}


DOCKINGCHILDBASEIMPL(BOOL)::SetLayeredWindowAttributes(COLORREF crKey, BYTE bAlpha, DWORD dwFlags)
{
	return CLayerFunctionManager::SetLayeredWindowAttributes(m_hWnd,crKey,bAlpha,dwFlags);
}

//ĈꉞWIȃev[g^ꉻNXp
class CDockingChildBase : public CDockingChildBaseT<CDockingChildBase>
{
public:
	DECLARE_WND_CLASS(_T("DockingChildBase"))
};
