#include "stdafx.h"
#include "FavoriteOrder.h"


CFavoriteOrderHandler::CFavoriteOrderHandler()
{
}
CFavoriteOrderHandler::~CFavoriteOrderHandler()
{
}

//WXgf[^ǂݍ
BOOL CFavoriteOrderHandler::ReadData(const CString& strDirPath)
{
	CString strKeyName = GetOrderKeyName(strDirPath);
	if(strKeyName.IsEmpty()) return FALSE;
	m_strRegKey = strKeyName;
	m_strDirPath = strDirPath;

	//WXgoCif[^擾
	CRegKey rkOrder;
	LONG lRet = rkOrder.Open(HKEY_CURRENT_USER, strKeyName);
	if (lRet != ERROR_SUCCESS)
		return FALSE;

	DWORD dwSize = 0;
	DWORD dwType = REG_BINARY;
	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, NULL, &dwSize);
	if (lRet == ERROR_FILE_NOT_FOUND){
		if(ReConstructData(strDirPath))
			return TRUE;
	}
	if (lRet != ERROR_SUCCESS || dwSize < sizeof(OrderDataHeader))
		return FALSE;

	BYTE* pByte = (BYTE*)_alloca((dwSize+10) * sizeof(BYTE));
	::memset(pByte, 0, dwSize+10);

	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, pByte, &dwSize);
	if (lRet != ERROR_SUCCESS)
		return FALSE;

	rkOrder.Close();

	/*FILE *fp = fopen("before.imo","wb");
	if(fp){
		fwrite(pByte,1,dwSize,fp);
		fclose(fp);
	}*/

	//f[^zm_aryDataɊi[
	m_aryData.clear();
	OrderDataHeader header = *(OrderDataHeader*)pByte; pByte+=sizeof(OrderDataHeader);
	LPBYTE pEnd = pByte + (header.dwFullSizem8 + 8 - sizeof(OrderDataHeader));
	int nCount = header.dwItemCount;
	for(int i=0; i<nCount; i++){
		OrderItemTemplate *pItem = (OrderItemTemplate*)pByte; //
		OrderItemData data; //փf[^Rs[
		data.dwSize = pItem->dwSize;
		data.dwPosition = pItem->dwPosition;
		CItemIDList idl(&pItem->idlName);
		data.idlName = idl;
		if(data.idlName.GetSize() & 1)	data.bPadding = TRUE;
		else							data.bPadding = FALSE;
		data.dwFlag = *(DWORD*)(pByte + pItem->dwSize - sizeof(DWORD));
		data.strName = MtlGetFileName(data.idlName.GetPath());

		m_aryData.push_back(data);
		pByte += pItem->dwSize;
		if(pByte > pEnd) break;
	}

	ReConstructData(m_strDirPath);

	return TRUE;
}

//f[^ǉ
BOOL CFavoriteOrderHandler::AddData(CString strFileName, DWORD dwPosition) //m_strDirPath̑΃pXŎw
{
	if(dwPosition == -1) dwPosition = m_aryData.size();
	if(dwPosition < 0 || m_aryData.size() < dwPosition) return FALSE;
	if(strFileName.IsEmpty()) return FALSE;

	//t@C̓tpXɒ
	CString strDir = m_strDirPath;
	MtlMakeSureTrailingBackSlash(strDir);
	if(strFileName.Find('\\') == -1) strFileName = strDir + strFileName;
	if(!MtlIsValidPath(strFileName)) return FALSE;

	//f[^𖄂߂
	OrderItemData item;
	item.dwPosition = dwPosition;
	item.idlName = strFileName;
	CItemIDList idlFolder = m_strDirPath;
	item.idlName -= idlFolder;
	int nSize = item.idlName.GetSize();
	item.bPadding = (nSize&1) ? TRUE : FALSE;
	item.dwSize = nSize + s_itemsize_without_idl + (item.bPadding ? 1 : 0);
	item.strName = MtlGetFileName(strFileName);

	//̓̍ڂ݂΍폜
	CString strPath = item.idlName.GetPath();
	FavoriteDataArray::iterator it = m_aryData.begin();
	while(1){
		if(it == m_aryData.end()) break;
		if(it->idlName.GetPath() == strPath){
			it = m_aryData.erase(it);
		}else{
			it++;
		}
	}

	//tH_ۂ𔻒
	if(MtlIsValidPath(strFileName)){
		CString strFavDir;
		MtlGetFavoritesFolder(strFavDir);
		if(strFavDir != m_strDirPath){
			if(MtlIsDirectory(strFileName))
				item.dwFlag = IE_MENUORDER_FOLDER;
			else
				item.dwFlag = IE_MENUORDER_ITEM;
		}else{
			item.dwFlag = IE_MENUORDER_ZERO;
		}
	}else{
		return FALSE;
	}

	//|WV炷
	for(it=m_aryData.begin(); it!=m_aryData.end(); it++){
		if(dwPosition <= it->dwPosition)
			it->dwPosition++;
	}
	m_aryData.push_back(item);

	//Ń\[g
	_FavoritesMenuNameCompare f(m_strDirPath);
	std::sort(m_aryData.begin(),m_aryData.end(),f);

	return TRUE;
}

BOOL CFavoriteOrderHandler::MoveData(DWORD dwSrcPos, DWORD dwDstPos)
{
	if(dwSrcPos == dwDstPos) return TRUE;
	if(dwSrcPos < 0 || dwDstPos < 0) return FALSE;

	int nSrcIndex = FindPosition(dwSrcPos);
	if(nSrcIndex == -1) return FALSE;

	FavoriteDataArray::iterator it;
	if(dwSrcPos < dwDstPos){
		//dwSrcPosȏdwDstPosȉ̃|WV
		for(it = m_aryData.begin(); it != m_aryData.end(); it++){
			if(dwSrcPos <= it->dwPosition && it->dwPosition <= dwDstPos)
				it->dwPosition--;
		}
	}else{
		//dwDstPosȏdwSrcPosȉ̃|WVグ
		for(it = m_aryData.begin(); it != m_aryData.end(); it++){
			if(dwDstPos <= it->dwPosition && it->dwPosition <= dwSrcPos)
				it->dwPosition++;
		}
	}
	m_aryData[nSrcIndex].dwPosition = dwDstPos;
	return TRUE;
}

BOOL CFavoriteOrderHandler::DeleteData(CString strFileName)
{
	if(strFileName.IsEmpty()) return FALSE;

	//t@C̓tpXɒ
	CString strDir = m_strDirPath;
	MtlMakeSureTrailingBackSlash(strDir);
	if(strFileName.Find('\\') == -1){
		strFileName = strDir + strFileName;
	}else{

	}
	if(!MtlIsValidPath(strFileName)) return FALSE;

	CItemIDList idl = strFileName;
	CItemIDList idlFolder = m_strDirPath;
	idl -= idlFolder;

	//t@Cڂ폜
	CString strPath = idl.GetPath();
	FavoriteDataArray::iterator it = m_aryData.begin();
	while(1){
		if(it == m_aryData.end()) break;
		if(it->idlName.GetPath() == strPath){
			DWORD dwPosition = it->dwPosition;
			m_aryData.erase(it);

			//̍ڂ̔ԍt
			for(FavoriteDataArray::iterator it2 = m_aryData.begin(); it2 != m_aryData.end(); it2++){
				if(dwPosition < it2->dwPosition)
					it2->dwPosition--;
			}
			return TRUE;
		}else{
			it++;
		}
	}
	return FALSE;
}

//f[^WXgɏ
BOOL CFavoriteOrderHandler::SaveData()
{
	//܂TCYm肳
	DWORD dwFullSize = 0;
	for(FavoriteDataArray::iterator it=m_aryData.begin(); it!=m_aryData.end(); it++){
		dwFullSize += it->dwSize;
	}
	dwFullSize += sizeof(OrderDataHeader); //wb_𑫂

	//m
	LPBYTE lpMem = (LPBYTE)new BYTE[dwFullSize];
	if(!lpMem) return FALSE;
	LPBYTE lpData = lpMem;

	//wb_f[^i[
	OrderDataHeader *pHeader = (OrderDataHeader*)lpData;
	pHeader->dwSize8 = 8;
	pHeader->dwFullSizem8 = dwFullSize - pHeader->dwSize8;
	pHeader->dwUnknown	= IE_MENUORDER_UNKNOWN1;
	pHeader->dwUnknown2 = IE_MENUORDER_UNKNOWN2;
	pHeader->dwItemCount = m_aryData.size();
	lpData += sizeof(OrderDataHeader);

	//ACef[^Rs[
	int nCount = m_aryData.size();
	for(int i=0; i<nCount; i++){
		LPBYTE lpStart = lpData;
		OrderItemData *pItem = &m_aryData[i];
		*(DWORD*)lpData = pItem->dwSize;		lpData+=4;
		*(DWORD*)lpData = pItem->dwPosition;	lpData+=4;
		int nSize = pItem->idlName.GetSize();
		::memcpy(lpData,(LPITEMIDLIST)pItem->idlName,nSize);	lpData+=nSize;
		if(pItem->bPadding) {
			*(BYTE*)lpData = 0; 				lpData+=1;
		}
		*(DWORD*)lpData = pItem->dwFlag;		lpData+=4;

		if(lpData - pItem->dwSize != lpStart)
			goto error;
	}

	//f[^
	{
		/*FILE *fp = fopen("after.imo","wb");
		if(fp){
			fwrite(lpMem,1,dwFullSize,fp);
			fclose(fp);
		}else{
			goto error;
		}*/

		CRegKey rkOrder;
		LONG lRet = rkOrder.Open(HKEY_CURRENT_USER, m_strRegKey);
		if (lRet != ERROR_SUCCESS)
			goto error;
		lRet = ::RegSetValueEx(rkOrder,_T("Order"),0,REG_BINARY,lpMem,dwFullSize);
		rkOrder.Close();
		if (lRet != ERROR_SUCCESS)
			goto error;
	}


	//J
	delete [] lpMem;
	return TRUE;
error:
	delete [] lpMem;
	return FALSE;
}

//f[^\z
BOOL CFavoriteOrderHandler::ReConstructData(CString strDirPath)
{
	//tH_̃t@C񋓂ăf[^Ɋ܂܂ĂȂ̂TĒǉ
	int nFirstCount = m_aryData.size();
	FavoriteDataArray::iterator it;
	for(it = m_aryData.begin(); it != m_aryData.end(); it++)
		it->bRef = FALSE;

	_FavoriteItemCollector funcClct(strDirPath,m_aryData);
	MtlForEachObject_OldShell(strDirPath,funcClct);
	int nValidCount = 0;
	it = m_aryData.begin();

	while(it != m_aryData.end()){
		if(!it->bRef) {
			for(FavoriteDataArray::iterator it2 = m_aryData.begin(); it2 != m_aryData.end(); it2++)
				if((int)it2->dwPosition > (int)it->dwPosition)
					it2->dwPosition--;
			it = m_aryData.erase(it);
		}else{
			if(it->dwPosition != FAVORITESORDER_NOTFOUND)
				nValidCount++;
			it++;

		}
	}

	//\[g
	_FavoritesMenuNameCompare funcComp(strDirPath);
	std::sort(m_aryData.begin(),m_aryData.end(),funcComp);

	//ǉf[^ɔԍ
	int j = nValidCount;
	int nCount = m_aryData.size();
	for(int i=0; i<nCount; i++){
		if(m_aryData[i].dwPosition == FAVORITESORDER_NOTFOUND){
			m_aryData[i].dwPosition = j;
			j++;
		}
	}

	return TRUE;
}

//w肵Oڂ̔ԍԂ
int CFavoriteOrderHandler::FindName(const CString& strFileName)
{
	CString strName = MtlGetFileName(strFileName);
	int nCount = m_aryData.size();
	for(int i=0; i<nCount; i++){
		if(strName == m_aryData[i].strName)
			return i;
	}
	return -1;
}

//w肵ʒuɂ鍀ڂ̔ԍԂ
int CFavoriteOrderHandler::FindPosition(DWORD dwPosition)
{
	int nCount = m_aryData.size();
	for(int i=0; i<nCount; i++){
		if(dwPosition == m_aryData[i].dwPosition)
			return i;
	}
	return -1;
}

CString CFavoriteOrderHandler::GetOrderKeyName(const CString& strDirPath)
{
	CString strFavRoot;
	MtlGetFavoritesFolder(strFavRoot);
	MtlMakeSureTrailingBackSlash(strFavRoot);

	CString strDir = strDirPath;
	MtlMakeSureTrailingBackSlash(strDir);
	if(strDir.Find(strFavRoot) == -1)
		return _T("");

	CString strKeyName = REGKEY_IE_MENUORDER_ROOT;
	CString strRelative = strDirPath.Right(strDirPath.GetLength() - strFavRoot.GetLength());
	if (!strRelative.IsEmpty())
		strKeyName += _T('\\') + strRelative;
	MtlRemoveTrailingBackSlash(strKeyName);

	return strKeyName;
}
