#pragma once

/*
	SimpleTree.h
	ȈՃc[\\邽߂̃ev[g

	m[h̏ŴƂĂ̖؍\Am[hNXƂ̊ǗNX
	\Bm[hɎf[^̓ev[gɂĎRɌł̂
	lXȖ؍\ɉpoB
	A@\̓VvȂ̂ŎԂ͂B
*/

/*
	CTreeNode<TNode>
	m[hƂĕKvȋ@\bvNXB
	em[hƑÕm[hAɍŏ̎qƍŌ̎qcB
	ăm[h̏ev[gɂĎ邱ƂoB

	TNodeƂė^^̏́AZqɂĖȂf[^Rs[
	邩ǂłBTNode^̒Ƀ|C^݂ꍇ
	ZqI[o[[hēw|C^݂Ȃ悤
	ӂKvBRs[RXgN^͎gpȂ͂ASzȂ
	`Ă悢B
*/

template<class TNode>
class CTreeNode
{
public:
	TNode Self;
	CTreeNode<TNode> *pPrev, *pNext, *pParent, *pFirstChild, *pLastChild;

	CTreeNode() : Self()
	{
		pPrev = pNext = pParent = pFirstChild = pLastChild = NULL;
	}

};


/*
	CSimpleTree<TNode>
	m[hǗč\𑀍삷邽߂̃NX

	TNode^̏m[h؍\ƂĊǗE삷邱ƂłB
	łCTreeNode<TNode>̃|C^NODEPTRđ삷B
*/
template<class TNode>
class CSimpleTree
{
public:
//^`
	typedef CTreeNode<TNode> NODE;
	typedef NODE* NODEPTR;

//oϐ
	NODE m_Root; //[gEeȂB̃m[h

	DWORD m_dwNewCount; //[NĎpJE^


//RXgN^
	CSimpleTree() : m_Root() , m_dwNewCount(0)
	{
	}

//fXgN^
	~CSimpleTree()
	{
		Clear();
	}

//\bh
public:
	NODEPTR Insert(NODEPTR pParent, TNode& NewItem)
	{
		if(!pParent) pParent = &m_Root;
		NODEPTR pNewNode = AllocNode();
		pNewNode->Self = NewItem; //g̃Rs[

		pNewNode->pParent = pParent;
		if(!pParent->pFirstChild){
			//ŏ̎qm[hƂēo^
			pParent->pFirstChild = pNewNode;
			pParent->pLastChild = pNewNode;
		}else{
			//Ō̎qm[ȟɂ
			NODEPTR pLastChild = pParent->pLastChild;
			pLastChild->pNext = pNewNode;
			pNewNode->pPrev = pLastChild;
			pParent->pLastChild = pNewNode;
		}
		return pNewNode;
	}

	BOOL Clear()
	{
		if(Delete(&m_Root) && m_dwNewCount == 0)
			return TRUE;
		ATLASSERT(FALSE); //[NĂ
		return FALSE;
	}

	BOOL Delete(NODEPTR pNode)
	{
		ATLASSERT(pNode);

		//܂wm[h̎qSď
		if(pNode->pFirstChild){
			DeleteChildren(pNode);
		}

		//֘Am[ĥȂύX
		if(pNode->pParent){
			if(pNode->pPrev){
				//OBȂ킿낪ΑO2Ȃł悢
				if(pNode->pNext){
					pNode->pPrev->pNext = pNode->pNext;
					pNode->pNext->pPrev = pNode->pPrev;
				}else{
					pNode->pPrev->pNext = NULL;
					pNode->pLastChild = pNode->pPrev;
				}
			}else{
				//ꂪԐ擪̎qm[hBȂ킿eƂ̊֌WύXKv
				if(pNode->pNext){
					pNode->pNext->pPrev = NULL;
					pNode->pParent->pFirstChild = pNode->pNext;
				}else{
					pNode->pParent->pFirstChild = NULL;
					pNode->pParent->pLastChild = NULL;
				}
			}
		}else{
			//[gł̂Ŕ
			return TRUE;
		}

		//Ƃ̂Ȃ肪ȂƂō폜
		FreeNode(pNode);
		return TRUE;
	}

private:
	BOOL DeleteChildren(NODEPTR pNode)
	{
		ATLASSERT(pNode);

		NODEPTR pChild = pNode->pFirstChild;
		if(!pChild) return TRUE;

		while(pChild->pNext){
			pChild = pChild->pNext;
			Delete(pChild->pPrev);
		}
		Delete(pChild);

		pNode->pFirstChild = NULL;
		pNode->pLastChild = NULL;
		return TRUE;
	}

public:
	TNode *GetData(NODEPTR pNode)
	{
		return (TNode *)pNode; //̂܂
	}


	NODEPTR GetRoot()
	{
		return &m_Root;
	}

	//֐ ڃ|C^ق
	NODEPTR GetFirstChild(NODEPTR pNode)
	{
		if(!pNode) pNode = &m_Root;
		return pNode->pFirstChild;
	}

	NODEPTR GetLastChild(NODEPTR pNode)
	{
		if(!pNode) pNode = &m_Root;
		return pNode->pLastChild:
	}

	NODEPTR GetPrev(NODEPTR pNode)
	{
		ATLASSERT(pNode);
		return pNode->pPrev;
	}

	NODEPTR GetNext(NODEPTR pNode)
	{
		ATLASSERT(pNode);
		return pNode->pNext;
	}

	NODEPTR GetParent(NODEPTR pNode)
	{
		ATLASSERT(pNode);
		return pNode->pParent;
	}

private:

	NODEPTR AllocNode()
	{
		m_dwNewCount++;
		return new NODE();
	}

	void FreeNode(NODEPTR pNode)
	{
		if(pNode){
			m_dwNewCount--;
			delete pNode;
		}
	}
};