#pragma once

#include <windows.h>
#include <atlbase.h>
#include <atlapp.h>
#include <atlmisc.h>
#include "SimpleTree.h"


//WXg̑ւƂȂKw\l
//CRegKeỹC^[tFCXɎt@Cւ̓o͂sNX
//SȌ͍݊lĂȂ
//悤ȎgŃWXgł͂Ȃt@Cɕۑ̂ōB
//CRegKeyŏoāÃNX(CFakeRegKey)ŏoȂƂ͒`""ƋLĂ
//߂l̃G[R[h͖{ԂĂ邩Ȃ̂œKȒlԂ


//CFakeRegManager̓t@CŜ̓o͂ǗNX
//CFakeRegKey̓WXg̃L[͕̓킷NX
//CFakeNode̓L[̃Ggf[^NX

class CFakeRegManager;
class CFakeNode //L[̓Gg
{
protected:
	friend class CFakeRegManager;
	CFakeRegManager *m_pManager;

	//m[h̎
	bool m_bKey; //true->L[:false->Gg

	//O
	CString m_strName;

	//GgƂẴf[^
	DWORD m_dwType;
	DWORD m_dwDataLen;
	BYTE *m_pData;

	BYTE *Alloc(DWORD dwSize);
	void Release();

	explicit CFakeNode(CFakeNode& objSrc); //Rs[RXgNg֎~
public:
	CFakeNode();
	~CFakeNode();
	CFakeNode& operator=(const CFakeNode& objSrc);

	//t@Co
	bool Read(FILE* fp);
	bool Write(FILE* fp);

	//̑
	CString GetName();
	void SetName(const CString& strName);
	CFakeRegManager *GetManager();
	bool IsKey();
	bool SetData(const BYTE* pData, DWORD dwSize, DWORD dwType);
	DWORD GetType();
	BYTE *GetData();
	DWORD GetDataSize();
};

typedef CSimpleTree<CFakeNode>::NODEPTR HFAKEKEY;







class CFakeRegKey
{
public:
	HFAKEKEY m_hKey;

protected:

	DWORD m_dwEnumIndex;
	HFAKEKEY m_hEnumKey;

	bool SetEntryValue(LPCTSTR lpszValueName, const BYTE* pData, DWORD dwSize, DWORD dwType);
	bool QueryEntryValue(LPCTSTR lpszValueName, BYTE*& pData, DWORD* pdwSize, DWORD *pdwType);

	HFAKEKEY ConvertReservedKey(HFAKEKEY hKey);

public:
	CFakeRegKey() throw();
	CFakeRegKey(CFakeRegKey& key) throw();
	explicit CFakeRegKey(HFAKEKEY hKey) throw();
	~CFakeRegKey() throw();

	CFakeRegKey& operator=(CFakeRegKey& key) throw();
	operator HFAKEKEY() const throw();

	void Attach(HFAKEKEY hKey) throw();
	HFAKEKEY Detach() throw();

	LONG Create(HFAKEKEY hKeyParent, LPCTSTR lpszKeyName,
		LPTSTR lpszClass = REG_NONE, DWORD dwOptions = REG_OPTION_NON_VOLATILE,
		REGSAM samDesired = KEY_READ | KEY_WRITE, LPSECURITY_ATTRIBUTES lpSecAttr = NULL,
		LPDWORD lpdwDisposition = NULL) throw();
	LONG Open(HFAKEKEY hKeyParent, LPCTSTR lpszKeyName,
		REGSAM samDesired = KEY_READ | KEY_WRITE) throw();
	LONG Close() throw();
	LONG Flush() throw();
	LONG EnumKey(DWORD iIndex, LPTSTR pszName, LPDWORD pnNameLength, FILETIME* pftLastWriteTime = NULL) throw();

	//ꉞS肾Aʓ|ɂȂ̂ŎgȂȂ͖̂`
	//LONG NotifyChangeKeyValue(BOOL bWatchSubtree, DWORD dwNotifyFilter, HANDLE hEvent, BOOL bAsync = TRUE) throw();
	//LONG GetKeySecurity(SECURITY_INFORMATION si, PSECURITY_DESCRIPTOR psd, LPDWORD pnBytes) throw();
	//LONG SetKeySecurity(SECURITY_INFORMATION si, PSECURITY_DESCRIPTOR psd) throw();

	/*ATL_DEPRECATED*/ LONG SetValue(DWORD dwValue, LPCTSTR lpszValueName);
	/*ATL_DEPRECATED*/ LONG SetValue(LPCTSTR lpszValue, LPCTSTR lpszValueName = NULL, bool bMulti = false, int nValueLen = -1);
	LONG SetValue(LPCTSTR pszValueName, DWORD dwType, const void* pValue, ULONG nBytes) throw();
	//LONG SetGUIDValue(LPCTSTR pszValueName, REFGUID guidValue) throw();
	//LONG SetBinaryValue(LPCTSTR pszValueName, const void* pValue, ULONG nBytes) throw();
	//LONG SetDWORDValue(LPCTSTR pszValueName, DWORD dwValue) throw();
	//LONG SetQWORDValue(LPCTSTR pszValueName, ULONGLONG qwValue) throw();
	//LONG SetStringValue(LPCTSTR pszValueName, LPCTSTR pszValue, DWORD dwType = REG_SZ) throw();
	//LONG SetMultiStringValue(LPCTSTR pszValueName, LPCTSTR pszValue) throw();

	/*ATL_DEPRECATED*/ LONG QueryValue(DWORD& dwValue, LPCTSTR lpszValueName);
	/*ATL_DEPRECATED*/ LONG QueryValue(LPTSTR pszValue, LPCTSTR lpszValueName, DWORD* pdwCount);
	LONG QueryValue(LPCTSTR pszValueName, DWORD* pdwType, void* pData, ULONG* pnBytes) throw();
	//LONG QueryGUIDValue(LPCTSTR pszValueName, GUID& guidValue) throw();
	//LONG QueryBinaryValue(LPCTSTR pszValueName, void* pValue, ULONG* pnBytes) throw();
	//LONG QueryDWORDValue(LPCTSTR pszValueName, DWORD& dwValue) throw();
	//LONG QueryQWORDValue(LPCTSTR pszValueName, ULONGLONG& qwValue) throw();
	//LONG QueryStringValue(LPCTSTR pszValueName, LPTSTR pszValue, ULONG* pnChars) throw();
	//LONG QueryMultiStringValue(LPCTSTR pszValueName, LPTSTR pszValue, ULONG* pnChars) throw();

	LONG DeleteSubKey(LPCTSTR lpszSubKey) throw();
	LONG RecurseDeleteKey(LPCTSTR lpszKey) throw();
	LONG DeleteValue(LPCTSTR lpszValue) throw();

	//Ǝ֐
	HFAKEKEY FindEntry(const CString& strEntryName);
	HFAKEKEY FindKey(const CString& strKeyName);
};



class CFakeRegManager
{
protected:
	friend class CFakeRegKey;

	CSimpleTree<CFakeNode> m_Tree;
	CString m_strSignature;

	bool LoadRoot(FILE* fp);
	bool LoadSub(HFAKEKEY hParentKey, FILE* fp);
	bool SaveSub(HFAKEKEY hParentKey, FILE* fp);

	HFAKEKEY CreateKey(HFAKEKEY hParentKey, const CString& strKeyName);
	HFAKEKEY CreateEntry(HFAKEKEY hParentKey, const CString& strEntryName);

public:
	CFakeRegManager();
	bool Load(const CString& strFileName);
	bool Save(const CString& strFileName);
	HFAKEKEY GetRoot();
	void Clear();
	bool RequestDelete(HFAKEKEY hKey, bool bRecursive);

	HFAKEKEY HFAKEKEY_CLASSES_ROOT;
	HFAKEKEY HFAKEKEY_CURRENT_USER;
	HFAKEKEY HFAKEKEY_LOCAL_MACHINE;
	HFAKEKEY HFAKEKEY_USERS;

};




LONG RegQueryValueFake(HFAKEKEY hKey, LPCTSTR lpValueName, LPDWORD lpReserved,
					 LPDWORD lpType, LPBYTE lpData, LPDWORD lpcbData);

LONG RegSetValueFake(HFAKEKEY hKey, LPCTSTR lpValueName, DWORD Reserved,
				   DWORD dwType, CONST BYTE *lpData, DWORD cbData);






/*LONG FakeRegQueryValueEx(HFAKEKEY hKey, LPCTSTR lpValueName, LPDWORD lpReserved, LPDWORD lpType, LPBYTE lpData, LPDWORD lpcbData);
{
	return ERROR_SUCCESS;
}*/

